
Directory do(
    docSlot("with(aPath)", "Returns a new instance with the provided path.")
    with := method(path, self clone setPath(path))

    parentDirectory := method(
		if(path == ".", return nil)
		p := self path pathComponent	
		if(p == "", p = ".")
		Directory clone setPath(p)
    )

    folders := method(
		items select(item, item type ==("Directory") and(item name != ".") and(item name != ".."))
    )

    isAccessible := method(
        r := self
		try(items) catch(Exception, e, r = nil)
		r
    )

    parents := method(
		list := List clone
		d := self
		while(d = d parentDirectory, list append(d))
		list reverse
    )

    accessibleParents := method(
		parents select(p, p isAccessible)
    )
    
    files := method(
		//writebr("path = ", path)
		items select(v, v type == "File")
    )
    
    fileNames := method(
		files mapInPlace(i, v, v name)
    )
    
    fileNamed := method(name,
		files detect(i, v, v name == name)
		//File clone setPath(Path with(path, name))
    )

    filesWithExtension := method(ext,
      if(ext containsSeq(".") not, ext = "." .. ext)
      files select(f, f name endsWithSeq(ext))
    )

    folderNamed := method(name,
		folders detect(i, v, v name == name)
    )

    remove := method(
        File clone setPath(self path) remove
    )

    folderNamedCreateIfAbsent := method(name,
		f := folderNamed(name)
		if(f, return f)
		createSubdirectory(name)
		folderNamed(name)
    )

    createFileNamed := method(name,
		f := fileNamed(name)
		if(f, return f)
		return File clone setPath(Path with(path, name))
    )
)


