Number do(
  constants := Object clone do(
    docSlot("constants pi", "Returns the constant pi.")
    pi := 3.14159265358979323846264338327950288

    docSlot("constants nan", "Returns a infinity constant.")    
    nan := (0/0)

    docSlot("constants inf", "Returns a not-a-number constant.")    
    inf := (1/0)
        
    docSlot("constants e", "Returns the constant e.")
    e  := 2.71828182845904523536028747135266249
  )

  asSimpleString := method(self asString)

  docSlot("to", "Convenience constructor that returns a cursor object representing the range of numbers from the receiver to the 'endingPoint' parameter. Increments over each item in that range by 1.")
  to := method(e, self toBy(e, 1))

  docSlot("toBy(endingPoint, incrementValue)", "Convenience constructor that returns a cursor object representing the range of numbers from the receiver to the 'endingPoint' parameter. Increments over each item in that range by the 'incrementValue' parameter.")
  toBy := method(e, i,
    if(i < 0, Exception raise("increment value must be non-negative"))
    Range clone setRange(self, e, i)
  )
)
