Range do(
  docSlot("asList", "Returns a list containing all the items within and including the ranges starting and ending points.")
  asList := method(
    lst := List clone
    self foreach(v, lst append(v))
    lst
  )

  docSlot("contains", "Returns a boolean value if the range contains the argument. This works independant of any increment value.")
  contains := method(v,
    Exception raise("'contains' method has no implementation.")
  )

  docSlot("select", "Operates the same as 'List select'")
  select := List getSlot("select")

  docSlot("map([value], body)", "Returns a new list which contains the result of the 'body' for every element stepped over in the range, from the starting point to the ending point inclusive.")
  map := method(
    a1 := call argAt(0)
    if(a1 isNil,
      Exception raise("'map' requires at least 1 argument")
      return
    )
    lst := List clone
    body := call argAt(1)
    if(body, valName := a1 name)
    if(a1 and body isNil, body = call argAt(0))
    loop(
      if(getSlot("valName"), call sender setSlot(valName, value))
      lst append(call sender doMessage(body))
      next ifFalse(break)
    )
    lst
  )
)

