Importer := Object clone do(
	type := "Importer"
    docDescription("A simple search path based auto-importer.")

    paths := List clone append("")
    debug := false
    
    addSearchPath    := method(p, paths append(p asSymbol))
    removeSearchPath := method(p, paths remove(p asSymbol))
    
    extensions := list("io")

    executeString := method(name, s,
		Lobby doString(s, name)
		r := Lobby getSlot(name)
		if(r, return r)
		Exception raise("Importer slot '" .. name .. "' missing after file load")
		nil    
    )
    
	execute_io := method(path, name, extension,
		p := Path with(path, name .. "." .. extension)
		s := File clone setPath(p) asBuffer
		executeString(name, s)
	)

	find := method(message, theObject,
		name := message name
		p := ?launchPath
		if(debug, writeln("Importer find '", name, "' ", message label, " ", message lineNumber, " ---------------------------"))
		if(p and(paths contains(p) not), paths atInsert(0, p))  
		if(name at(0) isUppercase, paths foreach(p, 
			extensions foreach(extension,
				if(p beginsWithSeq("/")) then(
					fullPath := Path with(p, name .. "." .. extension) asSymbol
				) else(
					fullPath := Path with(Directory currentWorkingDirectory, p, name .. "." .. extension) asSymbol
				)
				//if(debug, writeln("Directory currentWorkingDirectory:", Directory currentWorkingDirectory))
				if(debug, writeln("cwd:                  ", Directory currentWorkingDirectory))
				if(debug, writeln("p:                    ", p))
				if(debug, writeln("Importer looking for: ", fullPath))
				//writeln("File clone setPath(\"" .. fullPath .. "\") exists = ", File clone setPath(fullPath) exists)
				if(File clone setPath(fullPath) exists, 
					r := self perform("execute_" .. extension, p, name, extension)
					if (r, return r)
				)
				)
			)
		)
		Exception raise(theObject type .. " does not respond to '" .. name .. "'")
    )

    docSlot("turnOn", "Turns on the Importer. Returns self.")    
    turnOn := method(Lobby forward := method(Importer find(call message, self)); self)

    docSlot("turnOff", "Turns off the Importer. Returns self.")    
    turnOff := method(Lobby removeSlot("forward"); self)
    turnOn
)

