
List popFirst := method(
    item := first
    if(item, removeAt(0))
    item
)

Message do( 
    addArg := method(m,
	self setArguments(self arguments add(m))
    )

    parse := method(tokens,
	if (tokens first isMessage == Nil, return Nil)
	//writeln("parse ", tokens first name)
    	m := Message clone
	m parseName(tokens)
	m parseArgs(tokens)
	m parseAttached(tokens)
	while(m parseNext(tokens), Nop)
	m
    )

    parseName := method(tokens,
	//writeln("parseName ", tokens first name)
	token := tokens first
	tokens popFirst
	setName(token name)
    )
    
    parseArgs := method(tokens,
	if (tokens first type != "OpenParen", return)
	tokens popFirst
	//writeln("parseArgs ", tokens first name)
	
	while(arg := parse(tokens), 
	    addArg(arg)
	    if (tokens first type != "Comma", break)
	    tokens popFirst
	)
	
	if (tokens first type != "CloseParen", Exception raise("Message", "missing close paren"))
	tokens popFirst
    )
    
    
    parseAttached := method(tokens,
	if (tokens first ?isMessage == Nil, return Nil)
	//writeln("parseAttached ", tokens first name)
	m := parse(tokens)
	if (m, 
	    setAttachedMessage(m)
	)
    )
    
    parseNext := method(tokens,
	if (tokens first type == "Terminator",
	    tokens popFirst
	    m := parse(tokens)
	    setNextMessage(m)
	    m
	)
	Nil
    )
)

Token := Object clone do(
    isMessage := method(
	t := self type
	t == "Identifier" or t == "Operator" or t == "MonoQuote" or t == "TriQuote"
    )
)

Compiler do(
    parse := method(text, 
	writeln("parsing: ", text)
	tokens := tokensForString(text)
	tokens foreach(t, t proto = Token)
	tokens parens := List clone
	m := Message parse(tokens)
	writeln("parsed:  ", m asString replace("\n", " "))
    )
)

Compiler parse("a b(c, d); e(f); g h")
Compiler parse("a := 1")
