IfTest := UnitTest clone do(

    setUp := method(
        self do(
            expr  := method(call sender expr  := true; false)
        )
    )

    """
    Object if := method(condition,
        index = if(condition, 1, 2)
        if(call message arguments size > index,
            call sender doMessage(call message argAt(index), call sender)
        ,
            if(condition, true, false)
        )
    )
    """

    testIfEval := method(
        if(expr)
        assertTrue(expr)
    )

    testTrue := method(
        assertTrue(if(true))
    )

    testTrueExpression := method(
        assertEquals(if(true, 1), 1)
    )

    testTrue2Expressions := method(
        assertEquals(if(true, 1, 2), 1)
    )

    testFalse := method(
        assertFalse(if(false))
    )

    testFalseExpression := method(
        assertFalse(if(false, 1))
    )

    testFalse2Expressions := method(
        assertEquals(if(false, 1, 2), 2)
    )

    testNil := method(
        assertFalse(if)
        assertFalse(if())
        assertFalse(if(nil))
    )

    testOtherTrue := method(
        assertTrue(if(Object))
        assertTrue(if(13))
        assertTrue(if("foo"))
    )

    testThenTrue := method(
        assertNil(true then(expr))
        assertTrue(expr)
    )

    testThenFalse := method(
        assertFalse(false then(expr))
        assertFalse(expr)
    )

    testThenNil := method(
        assertNil(nil then(expr))
        assertFalse(expr)
    )

    testElseTrue := method(
        assertTrue(true else(expr))
        assertFalse(expr)
    )

    testElseFalse := method(
        assertNil(false else(expr))
        assertTrue(expr)
    )

    testElseNil := method(
        assertNil(nil else(expr))
        assertFalse(expr)
    )

    testElseIfTrueTrue := method(
        assertTrue(true elseif(expr; true))
        assertFalse(expr)
    )

    testElseIfTrueFalse := method(
        assertTrue(true elseif(expr; false))
        assertFalse(expr)
    )

    testElseIfFalseTrue := method(
        assertTrue(false elseif(expr; true))
        assertTrue(expr)
    )

    testElseIfFalseFalse := method(
        assertFalse(false elseif(expr; false))
        assertTrue(expr)
    )

    testElseIfNilTrue := method(
        assertNil(nil elseif(expr; true))
        assertFalse(expr)
    )

    testElseIfNilFalse := method(
        assertNil(nil elseif(expr; false))
        assertFalse(expr)
    )
)
